capture log close
log using guatemala, replace text
set more off

use guatemala, clear

* three-level random intercept model
gllamm immun kid2p indNoSpa indSpa  momEdPri momEdSec husEdPri husEdSec  ///
   husEdDK rural pcInd81, family(binomial) link(logit) i(mom cluster) ///
   nip(5)
  
matrix a=e(b) 
gllamm immun kid2p indNoSpa indSpa  momEdPri momEdSec husEdPri husEdSec  ///
   husEdDK rural pcInd81, family(binomial) link(logit) i(mom cluster) ///
   from(a) adapt
gllamm, eform

estimates store model1

* model with fewer covariates
matrix a=e(b)
gllamm immun kid2p rural pcInd81, family(binomial) link(logit) ///
   i(mom cluster) from(a) skip adapt
gllamm, eform
   
estimates store model2

* random coefficient model
gen cons=1
eq inter: cons
eq slope: kid2p
matrix a = e(b)
matrix a = (a,.2,0)
gllamm immun kid2p rural pcInd81, family(binomial) link(logit) i(mom cluster) ///
   nrf(1 2) eqs(inter inter slope) nip(8 4 4) from(a) copy adapt eform
estimates store model3

lrtest model2 model3

* prediction
gllapred zeta, u
sort cluster mom
list cluster mom zetam1 zetam2 zetam3 in 1/9, clean noobs

egen pick_comm = tag(cluster)
twoway scatter zetam3 zetam2 if pick_com==1, xtitle(Intercept) ytitle(Slope)
 
log close
exit
