capture log close
log using pefr3, text replace
set scheme sj
set more off

use pefr, clear
reshape long wm wp, i(id) j(occasion) 
gen i=_n 
reshape long w, i(i) j(meth) string 
sort id meth occasion
list id meth occasion w in 1/8, clean noobs

encode meth, gen(method) 
recode method 2=0

* two-level models using xtmixed

xtmixed w || id:, mle
estimates store model1

xtmixed w method || id:, mle
estimates store model2

twoway (scatter w id if method==0, msymbol(circle)) ///
       (scatter w id if method==1, msymbol(circle_hollow)), ///
       xtitle(Subject id) ytitle(Peak expiratory folow measurements) ///
       legend( order(1 "Wright" 2 "Mini Wright")) yline(`w_mean')

* three-level model using xtmixed
xtmixed w method || id: || method:, mle
estimates store model3

lrtest model2 model3

xtmixed w || id: || method:, mle

* prediction using xtmixed
predict subj instr, reffects
sort id method
label def m 0 "Wright" 1 "Mini Wright"
label values method m
list id method subj instr if id<8&occasion==1, clean noobs

log close
exit
