capture log close
log using grunfeld, replace text
set more off
set scheme sj

use grunfeld, clear

* crossed error-components model
xtmixed I F C || _all: R.fn || yr:, mle  
*xtmixed I F C || _all: R.yr || fn: , mle 

* prediction
predict firm year, reffects
sort fn yr
list fn firmname yr firm year if yr<1938&fn<5, clean noobs

* graphs
gen reffpart = firm+year

twoway (line reffpart yr, connect(ascending))        ///
   (scatter reffpart yr if yr==1954, msymbol(none) mlabel(firmname) mlabpos(3)), ///
   xtitle(Year) ytitle(Predicted random effects of firm and year) ///
   xscale(range(1935 1958)) legend(off)

twoway line year yr if fn==1, xtitle(Year) ///
  ytitle(Predicted random effect for year)

log close
exit
